From fda43f0534e2de25f4ff48092a640c69ee9abf2e Mon Sep 17 00:00:00 2001
From: Jack Magne <jmagne@redhat.com>
Date: Sat, 21 Jan 2012 17:39:26 -0800
Subject: [PATCH] KRA changes for archiving and recovering symmetric keys  and
 passphrases.

Ticket #66 and #68.

Add ability to archive and recover symmetric keys and passphrases using rest interface.
Enhanced test client to test out new functionality.
Provided support to return recovered data either wrapped by symmetric key or wrapped in PBE password based encryption blob.
---
 pki/base/ca/shared/conf/schema.ldif                |   17 +-
 .../com/netscape/certsrv/dbs/keydb/IKeyRecord.java |   12 +
 .../src/com/netscape/certsrv/request/IRequest.java |   14 +-
 .../netscape/certsrv/security/IEncryptionUnit.java |   21 +
 .../certsrv/security/ITransportKeyUnit.java        |    2 +
 .../cms/servlet/key/KeyResourceService.java        |    4 +-
 .../cms/servlet/key/KeysResourceService.java       |    3 +-
 .../com/netscape/cms/servlet/key/model/KeyDAO.java |  101 +++++-
 .../netscape/cms/servlet/key/model/KeyData.java    |   19 +
 .../cms/servlet/request/KeyRequestResource.java    |    3 +
 .../servlet/request/KeyRequestResourceService.java |   16 +
 .../cms/servlet/request/model/KeyRequestDAO.java   |   73 ++++-
 .../servlet/request/model/RecoveryRequestData.java |   21 +
 .../src/com/netscape/cmscore/dbs/KeyDBSchema.java  |    3 +
 .../src/com/netscape/cmscore/dbs/KeyRecord.java    |   26 ++
 .../com/netscape/cmscore/dbs/KeyRepository.java    |   15 +-
 .../netscape/cms/servlet/test/DRMRestClient.java   |   16 +-
 .../src/com/netscape/cms/servlet/test/DRMTest.java |  219 ++++++++---
 pki/base/kra/shared/conf/schema.ldif               |   17 +-
 .../kra/src/com/netscape/kra/ArchiveOptions.java   |  154 ++++++++
 .../kra/src/com/netscape/kra/EncryptionUnit.java   |  355 ++++++++++++------
 .../src/com/netscape/kra/EnrollmentService.java    |  117 +------
 pki/base/kra/src/com/netscape/kra/KRAService.java  |    7 +-
 .../netscape/kra/SecurityDataRecoveryService.java  |  395 ++++++++++++++++++++
 .../src/com/netscape/kra/SecurityDataService.java  |  163 ++++++++
 pki/base/ocsp/shared/conf/schema.ldif              |   17 +-
 pki/base/tks/shared/conf/schema.ldif               |   17 +-
 27 files changed, 1527 insertions(+), 300 deletions(-)
 create mode 100644 pki/base/kra/src/com/netscape/kra/ArchiveOptions.java
 create mode 100644 pki/base/kra/src/com/netscape/kra/SecurityDataRecoveryService.java
 create mode 100644 pki/base/kra/src/com/netscape/kra/SecurityDataService.java

diff --git a/pki/base/ca/shared/conf/schema.ldif b/pki/base/ca/shared/conf/schema.ldif
index caf71e9..70578e2 100644
--- a/pki/base/ca/shared/conf/schema.ldif
+++ b/pki/base/ca/shared/conf/schema.ldif
@@ -161,6 +161,21 @@ attributeTypes: ( keySize-oid NAME 'keySize' DESC 'CMS defined attribute' SYNTAX
 dn: cn=schema
 changetype: modify
 add: attributeTypes
+attributeTypes: ( clientId-oid NAME 'clientId' DESC 'CMS defined attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 X-ORIGIN 'user defined' )
+
+dn: cn=schema
+changetype: modify
+add: attributeTypes
+attributeTypes: ( dataType-oid NAME 'dataType' DESC 'CMS defined attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 X-ORIGIN 'user defined' )
+
+dn: cn=schema
+changetype: modify
+add: attributeTypes
+attributeTypes: ( status-oid NAME 'status' DESC 'CMS defined attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 X-ORIGIN 'user defined' )
+
+dn: cn=schema
+changetype: modify
+add: attributeTypes
 attributeTypes: ( keyState-oid NAME 'keyState' DESC 'CMS defined attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 X-ORIGIN 'user defined' )
 
 dn: cn=schema
@@ -446,7 +461,7 @@ objectClasses: ( userDetails-oid NAME 'userDetails' DESC 'CMS defined class' SUP
 dn: cn=schema
 changetype: modify
 add: objectClasses
-objectClasses: ( keyRecord-oid NAME 'keyRecord' DESC 'CMS defined class' SUP top STRUCTURAL MUST cn MAY ( serialno $ dateOfCreate $ dateOfModify $ keyState $ privateKeyData $ ownerName $ keySize $ metaInfo $ dateOfArchival $ dateOfRecovery $ algorithm $ publicKeyFormat $ publicKeyData $ archivedBy ) X-ORIGIN 'user defined' )
+objectClasses: ( keyRecord-oid NAME 'keyRecord' DESC 'CMS defined class' SUP top STRUCTURAL MUST cn MAY ( serialno $ dateOfCreate $ dateOfModify $ keyState $ privateKeyData $ ownerName $ keySize $ metaInfo $ dateOfArchival $ dateOfRecovery $ algorithm $ publicKeyFormat $ publicKeyData $ archivedBy $ clientId $ dataType $ status ) X-ORIGIN 'user defined' )
 
 dn: cn=schema
 changetype: modify
diff --git a/pki/base/common/src/com/netscape/certsrv/dbs/keydb/IKeyRecord.java b/pki/base/common/src/com/netscape/certsrv/dbs/keydb/IKeyRecord.java
index 010661d..4007f3c 100644
--- a/pki/base/common/src/com/netscape/certsrv/dbs/keydb/IKeyRecord.java
+++ b/pki/base/common/src/com/netscape/certsrv/dbs/keydb/IKeyRecord.java
@@ -40,6 +40,10 @@ public interface IKeyRecord {
     public static final String ATTR_MODIFY_TIME = "keyModifyTime";
     public static final String ATTR_META_INFO = "keyMetaInfo";
     public static final String ATTR_ARCHIVED_BY = "keyArchivedBy";
+    public static final String ATTR_CLIENT_ID = "clientId";
+    public static final String ATTR_DATA_TYPE = "dataType";
+    public static final String ATTR_STATUS = "status";
+    
 
     // key state
     public static final String STATUS_ANY = "ANY";
@@ -86,6 +90,14 @@ public interface IKeyRecord {
     public Integer getKeySize() throws EBaseException;
 
     /**
+     * Retrieves client ID.
+     * 
+     * @return client id
+     * @exception EBaseException failed to retrieve client id
+     */
+    public String getClientId() throws EBaseException;
+
+    /**
      * Retrieves archiver identifier.
      * 
      * @return archiver uid
diff --git a/pki/base/common/src/com/netscape/certsrv/request/IRequest.java b/pki/base/common/src/com/netscape/certsrv/request/IRequest.java
index 19b8308..6443d64 100644
--- a/pki/base/common/src/com/netscape/certsrv/request/IRequest.java
+++ b/pki/base/common/src/com/netscape/certsrv/request/IRequest.java
@@ -69,8 +69,6 @@ public interface IRequest {
     public static final String CLA_UNCERT4CRL_REQUEST = "uncert4crl";
     public static final String NETKEY_KEYGEN_REQUEST = "netkeyKeygen";
     public static final String NETKEY_KEYRECOVERY_REQUEST = "netkeyKeyRecovery";
-    public static final String SECURITY_DATA_ENROLLMENT_REQUEST = "securityDataEnrollment";
-    public static final String SECURITY_DATA_RECOVERY_REQUEST = "securityDataRecovery";
 
     public static final String REQUESTOR_NAME = "csrRequestorName";
     public static final String REQUESTOR_PHONE = "csrRequestorPhone";
@@ -152,6 +150,18 @@ public interface IRequest {
     public final static String NETKEY_ATTR_USER_CERT = "cert";
     public final static String NETKEY_ATTR_KEY_SIZE = "keysize";
 
+    //Security Data request attributes
+    public static final String SECURITY_DATA_ENROLLMENT_REQUEST = "securityDataEnrollment";
+    public static final String SECURITY_DATA_RECOVERY_REQUEST = "securityDataRecovery";
+    public static final String SECURITY_DATA_CLIENT_ID = "clientID";
+    public static final String SECURITY_DATA_TYPE = "dataType";
+    public static final String SECURITY_DATA_STATUS = "status";
+    public static final String SECURITY_DATA_TRANS_SESS_KEY = "transWrappedSessKey";
+    public static final String SECURITY_DATA_SESS_PASS_PHRASE = "sessWrappedPassPhrase";
+    public static final String SECURITY_DATA_IV_STRING_IN = "iv_in";
+    public static final String SECURITY_DATA_IV_STRING_OUT = "iv_out";
+    
+    
     // requestor type values.
     public static final String REQUESTOR_EE = "EE";
     public static final String REQUESTOR_RA = "RA";
diff --git a/pki/base/common/src/com/netscape/certsrv/security/IEncryptionUnit.java b/pki/base/common/src/com/netscape/certsrv/security/IEncryptionUnit.java
index e318188..de67a9e 100644
--- a/pki/base/common/src/com/netscape/certsrv/security/IEncryptionUnit.java
+++ b/pki/base/common/src/com/netscape/certsrv/security/IEncryptionUnit.java
@@ -20,6 +20,7 @@ package com.netscape.certsrv.security;
 import java.security.PublicKey;
 
 import org.mozilla.jss.crypto.PrivateKey;
+import org.mozilla.jss.crypto.SymmetricKey;
 
 import com.netscape.certsrv.base.EBaseException;
 
@@ -46,6 +47,16 @@ public interface IEncryptionUnit extends IToken {
      * @exception EBaseException failed to wrap
      */
     public byte[] wrap(PrivateKey priKey) throws EBaseException;
+    
+    /**
+     * Wraps data. The given key will be wrapped by the
+     * private key in this unit.
+     * 
+     * @param symKey symmetric key to be wrapped
+     * @return wrapped data
+     * @exception EBaseException failed to wrap
+     */
+    public byte[] wrap(SymmetricKey symKey) throws EBaseException;
 
     /**
      * Verifies the given key pair.
@@ -72,6 +83,16 @@ public interface IEncryptionUnit extends IToken {
             byte symmAlgParams[], byte privateKey[],
             PublicKey pubKey)
             throws EBaseException;
+    
+    public SymmetricKey unwrap(byte wrappedKeyData[])
+            throws EBaseException;
+    
+    public SymmetricKey unwrap_symmetric(byte sessionKey[], String symmAlgOID,
+            byte symmAlgParams[], byte symmetricKey[])
+            throws EBaseException;
+    
+    public SymmetricKey unwrap_sym(byte encSymmKey[],
+            SymmetricKey.Usage usage);
 
     /**
      * Unwraps data. This method rebuilds the private key by
diff --git a/pki/base/common/src/com/netscape/certsrv/security/ITransportKeyUnit.java b/pki/base/common/src/com/netscape/certsrv/security/ITransportKeyUnit.java
index 0a012e8..a3bea72 100644
--- a/pki/base/common/src/com/netscape/certsrv/security/ITransportKeyUnit.java
+++ b/pki/base/common/src/com/netscape/certsrv/security/ITransportKeyUnit.java
@@ -41,6 +41,8 @@ public interface ITransportKeyUnit extends IEncryptionUnit {
      */
     public org.mozilla.jss.crypto.X509Certificate getCertificate();
 
+    public SymmetricKey unwrap_sym(byte encSymmKey[], SymmetricKey.Usage usage);
+    
     public SymmetricKey unwrap_sym(byte encSymmKey[]);
 
     public SymmetricKey unwrap_encrypt_sym(byte encSymmKey[]);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/key/KeyResourceService.java b/pki/base/common/src/com/netscape/cms/servlet/key/KeyResourceService.java
index 887820c..6c4375a 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/key/KeyResourceService.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/key/KeyResourceService.java
@@ -111,13 +111,13 @@ public class KeyResourceService extends CMSResourceService implements KeyResourc
         
         // confirm request is in approved state
         String status = reqInfo.getRequestStatus();
-        if (!status.equals(RequestStatus.APPROVED.toString())) {
+        if (!status.equals(RequestStatus.APPROVED.toString()) && !status.equals(RequestStatus.COMPLETE.toString())) {
             // log error
             throw new WebApplicationException(Response.Status.UNAUTHORIZED);
         }
         
         String keyURL = reqInfo.getKeyURL();
-        return keyURL.substring(keyURL.lastIndexOf("/")); 
+        return keyURL.substring(keyURL.lastIndexOf("/") + 1); 
     }
 
 }
diff --git a/pki/base/common/src/com/netscape/cms/servlet/key/KeysResourceService.java b/pki/base/common/src/com/netscape/cms/servlet/key/KeysResourceService.java
index 471abc1..513d5c2 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/key/KeysResourceService.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/key/KeysResourceService.java
@@ -76,7 +76,8 @@ public class KeysResourceService extends CMSResourceService implements KeysResou
         }
         
         if (clientID != null) {
-            filter += "(clientID=\'" + clientID + "\')";
+           // filter += "(clientID=\'" + clientID + "\')";
+            filter += "(clientID=" + clientID + ")";
             matches ++;
         }
         
diff --git a/pki/base/common/src/com/netscape/cms/servlet/key/model/KeyDAO.java b/pki/base/common/src/com/netscape/cms/servlet/key/model/KeyDAO.java
index 5fd17a3..c2853ea 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/key/model/KeyDAO.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/key/model/KeyDAO.java
@@ -20,6 +20,7 @@ package com.netscape.cms.servlet.key.model;
 import java.math.BigInteger;
 import java.util.ArrayList;
 import java.util.Enumeration;
+import java.util.Hashtable;
 import java.util.List;
 
 import javax.ws.rs.core.UriBuilder;
@@ -29,7 +30,13 @@ import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.dbs.keydb.IKeyRecord;
 import com.netscape.certsrv.dbs.keydb.IKeyRepository;
 import com.netscape.certsrv.kra.IKeyRecoveryAuthority;
+import com.netscape.certsrv.request.IRequest;
+import com.netscape.certsrv.request.IRequestQueue;
+import com.netscape.certsrv.request.RequestId;
+import com.netscape.certsrv.request.RequestStatus;
 import com.netscape.cms.servlet.request.model.RecoveryRequestData;
+import com.netscape.kra.RecoveryService;
+import com.netscape.kra.SecurityDataRecoveryService;
 
 /**
  * @author alee
@@ -38,11 +45,13 @@ import com.netscape.cms.servlet.request.model.RecoveryRequestData;
 public class KeyDAO {
 
     private IKeyRepository repo;
+    private IKeyRecoveryAuthority kra;
+    private IRequestQueue queue;
     
     public KeyDAO() {
-        IKeyRecoveryAuthority kra = null;
         kra = ( IKeyRecoveryAuthority ) CMS.getSubsystem( "kra" );
         repo = kra.getKeyRepository();
+        queue = kra.getRequestQueue();
     }
     /**
      * Returns list of keys meeting specified search filter.
@@ -82,15 +91,95 @@ public class KeyDAO {
         KeyData keyData = null;
         BigInteger serial = new BigInteger(keyId);
         
-        // get wrapped key
+        String rId = data.getRequestId();
+        
+        String transWrappedSessionKey = null;
+        String sessionWrappedPassphrase = null;
+        
+        IRequest  request = queue.findRequest(new RequestId(rId));
+        
+        if (request == null) {
+            return null;
+        }
+        
+     // get wrapped key
         IKeyRecord rec = repo.readKeyRecord(serial);
         if (rec == null) {
-            // key does not exist
-            // log the error
             return null;  
         }
-        // TODO unwrap the key and wrap with the credential in RecoveryRequestData
-        // need to figure out how to do this with jmagne 
+        
+        Hashtable<String, Object> params = kra.getVolatileRequest(
+                request.getRequestId());
+        
+        
+        String sessWrappedKeyData = null;
+        String passWrappedKeyData = null;
+        String nonceData = null;
+        
+        if ( params != null) {
+           sessWrappedKeyData = (String) params.get( SecurityDataRecoveryService.ATTR_SESS_WRAPPED_DATA);
+           passWrappedKeyData = (String) params.get( SecurityDataRecoveryService.ATTR_PASS_WRAPPED_DATA);
+           nonceData = (String) params.get( IRequest.SECURITY_DATA_IV_STRING_OUT);
+        } else {
+            throw new EBaseException("Can't obtain Volatile params in KeyDAO.getKey!");
+        }
+        
+        if ( sessWrappedKeyData != null || passWrappedKeyData != null) {
+            keyData = new KeyData();
+            
+        } else {
+            // The data has not yet been set, let's see if the RecoveryRequestData contains
+            // the info. If so, process the request at this point.
+            
+            transWrappedSessionKey   = data.getTransWrappedSessionKey();
+            sessionWrappedPassphrase = data.getSessionWrappedPassphrase();
+            nonceData = data.getNonceData();
+            
+            if (sessionWrappedPassphrase != null) {
+                params.put(RecoveryService.ATTR_TRANSPORT_PWD, sessionWrappedPassphrase);
+            }
+                
+            if ( transWrappedSessionKey != null) {
+                params.put(IRequest.SECURITY_DATA_TRANS_SESS_KEY, transWrappedSessionKey);
+            }
+            
+            if ( nonceData != null) {
+                params.put(IRequest.SECURITY_DATA_IV_STRING_IN, nonceData);
+            }
+                
+            try {
+                // Has to be in this state or it won't go anywhere.
+                request.setRequestStatus(RequestStatus.BEGIN);
+                queue.processRequest(request);
+            } catch ( EBaseException e) {
+                kra.destroyVolatileRequest(request.getRequestId());
+            }
+
+            nonceData = null;
+            keyData = new KeyData();
+            if ( keyData != null) {
+                sessWrappedKeyData = (String) params.get( SecurityDataRecoveryService.ATTR_SESS_WRAPPED_DATA);
+                passWrappedKeyData = (String) params.get( SecurityDataRecoveryService.ATTR_PASS_WRAPPED_DATA);
+                nonceData = (String) params.get( IRequest.SECURITY_DATA_IV_STRING_OUT);
+                    
+            }
+        }
+        
+        if ( keyData != null) {
+            if ( sessWrappedKeyData != null) {
+                keyData.setWrappedPrivateData(sessWrappedKeyData);
+            }
+            if ( passWrappedKeyData != null) {
+                keyData.setWrappedPrivateData(passWrappedKeyData);
+            }
+            if ( nonceData != null) {
+                keyData.setNonceData(nonceData);
+            }
+            
+            kra.destroyVolatileRequest(request.getRequestId());
+        }
+        
+        queue.markAsServiced(request);
         
         return keyData;
     }
diff --git a/pki/base/common/src/com/netscape/cms/servlet/key/model/KeyData.java b/pki/base/common/src/com/netscape/cms/servlet/key/model/KeyData.java
index 0e6e80d..42a6bbf 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/key/model/KeyData.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/key/model/KeyData.java
@@ -36,6 +36,9 @@ public class KeyData {
     @XmlElement
     String wrappedPrivateData;
     
+    @XmlElement
+    String nonceData;
+    
     public KeyData() {
         // required for JAXB (defaults)
     }
@@ -54,4 +57,20 @@ public class KeyData {
         this.wrappedPrivateData = wrappedPrivateData;
     }
     
+    /**
+     * @return the nonceData
+     */
+    
+    public String getNonceData() {
+        return nonceData;
+    }
+    
+    /**
+     * @param nonceData the nonceData to set
+     */
+    
+    public void setNonceData(String nonceData) {
+        this.nonceData = nonceData;
+    }
+    
 }
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/KeyRequestResource.java b/pki/base/common/src/com/netscape/cms/servlet/request/KeyRequestResource.java
index 146b03d..656768f 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/KeyRequestResource.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/KeyRequestResource.java
@@ -14,6 +14,9 @@ import com.netscape.cms.servlet.request.model.RecoveryRequestData;
 
 @Path("/keyrequest")
 public interface KeyRequestResource {
+    public final String SYMMETRIC_KEY_TYPE = "symmetricKey";
+    public final String PASS_PHRASE_TYPE = "passPhrase";
+    public final String ASYMMETRIC_KEY_TYPE = "asymmetricKey";
 
     /**
      * Used to retrieve key request info for a specific request
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/KeyRequestResourceService.java b/pki/base/common/src/com/netscape/cms/servlet/request/KeyRequestResourceService.java
index da08c4d..2a2d5c8 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/KeyRequestResourceService.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/KeyRequestResourceService.java
@@ -69,6 +69,10 @@ public class KeyRequestResourceService extends CMSResourceService implements Key
 
     public KeyRequestInfo archiveKey(ArchivalRequestData data) {
         // auth and authz
+        if ( data == null ) {
+            throw new WebApplicationException(Response.Status.NOT_FOUND);
+        }
+        
         KeyRequestDAO dao = new KeyRequestDAO();
         KeyRequestInfo info;
         try {
@@ -89,6 +93,9 @@ public class KeyRequestResourceService extends CMSResourceService implements Key
 
     public KeyRequestInfo recoverKey(RecoveryRequestData data) {
         // auth and authz
+        if ( data == null ) {
+            throw new WebApplicationException(Response.Status.NOT_FOUND);
+        }
         KeyRequestDAO dao = new KeyRequestDAO();
         KeyRequestInfo info;
         try {
@@ -102,6 +109,9 @@ public class KeyRequestResourceService extends CMSResourceService implements Key
     }
     
     public void approveRequest(@PathParam("id") String id) {
+        if ( id == null) {
+            throw new WebApplicationException(Response.Status.NOT_FOUND);
+        }
         // auth and authz
         KeyRequestDAO dao = new KeyRequestDAO();
         try {
@@ -114,6 +124,9 @@ public class KeyRequestResourceService extends CMSResourceService implements Key
     }
     
     public void rejectRequest(@PathParam("id") String id) {
+        if ( id == null) {
+            throw new WebApplicationException(Response.Status.NOT_FOUND);
+        }
         // auth and authz
         KeyRequestDAO dao = new KeyRequestDAO();
         try {
@@ -126,6 +139,9 @@ public class KeyRequestResourceService extends CMSResourceService implements Key
     }
          
     public void cancelRequest(@PathParam("id") String id) {
+        if ( id == null) {
+            throw new WebApplicationException(Response.Status.NOT_FOUND);
+        }
         // auth and authz
         KeyRequestDAO dao = new KeyRequestDAO();
         try {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/model/KeyRequestDAO.java b/pki/base/common/src/com/netscape/cms/servlet/request/model/KeyRequestDAO.java
index 16da23d..e7cbd68 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/model/KeyRequestDAO.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/model/KeyRequestDAO.java
@@ -19,6 +19,7 @@ package com.netscape.cms.servlet.request.model;
 
 import java.net.URI;
 import java.util.ArrayList;
+import java.util.Hashtable;
 import java.util.List;
 
 import javax.ws.rs.core.MultivaluedMap;
@@ -35,6 +36,8 @@ import com.netscape.certsrv.request.IRequestVirtualList;
 import com.netscape.certsrv.request.RequestId;
 import com.netscape.certsrv.request.RequestStatus;
 import com.netscape.cms.servlet.base.model.Link;
+import com.netscape.certsrv.profile.IEnrollProfile;
+import com.netscape.kra.RecoveryService;
 
 /**
  * @author alee
@@ -42,6 +45,9 @@ import com.netscape.cms.servlet.base.model.Link;
  */
 public class KeyRequestDAO {
     private IRequestQueue queue;
+    private IKeyRecoveryAuthority kra;
+    
+    private static String REQUEST_ARCHIVE_OPTIONS = IEnrollProfile.REQUEST_ARCHIVE_OPTIONS;
     
     private String[] vlvFilters = {
             "(requeststate=*)", "(requesttype=enrollment)",
@@ -56,8 +62,9 @@ public class KeyRequestDAO {
             "(&(requeststate=complete)(requesttype=recovery))"
     };
     
+    public static final String ATTR_SERIALNO = "serialNumber";
+    
     public KeyRequestDAO() {
-        IKeyRecoveryAuthority kra = null;
         kra = ( IKeyRecoveryAuthority ) CMS.getSubsystem( "kra" );
         queue = kra.getRequestQueue();
     }
@@ -104,6 +111,10 @@ public class KeyRequestDAO {
             // We should think about whether they should be, or if we need to
             // limit the number of results returned.
             IRequestList requests = queue.listRequestsByFilter(filter, maxResults, maxTime);
+            
+            if ( requests == null) {
+                return null;
+            }
             while (requests.hasMoreElements()) {
                 RequestId rid = (RequestId) requests.nextElement();
                 IRequest request = queue.findRequest(rid);
@@ -168,10 +179,34 @@ public class KeyRequestDAO {
      * @throws EBaseException 
      */
     public KeyRequestInfo submitRequest(ArchivalRequestData data, UriInfo uriInfo) throws EBaseException {
+        String clientId = data.getClientId();
+        String wrappedSecurityData = data.getWrappedPrivateData();
+        String dataType = data.getDataType();
+        
+        KeyRequestInfos alreadyWithClientID =  null;
+        
+        if (clientId != null) {
+            alreadyWithClientID = listRequests("(extdata" + "-" + IRequest.SECURITY_DATA_CLIENT_ID+"=" + clientId + ")" , 0, 1, 1,10, 
+                 uriInfo);
+        }
+        
+        if ( alreadyWithClientID != null ) {
+            throw new EBaseException("Client ID already exists! ID: " + clientId);
+        }
+                
         IRequest request = queue.newRequest(IRequest.SECURITY_DATA_ENROLLMENT_REQUEST);
+        
+        request.setExtData(REQUEST_ARCHIVE_OPTIONS, wrappedSecurityData);
+        request.setExtData(IRequest.SECURITY_DATA_CLIENT_ID, clientId);
+        request.setExtData(IRequest.SECURITY_DATA_TYPE, dataType);
+        
+        //request.setExtData
         //TODO : 
         //set data using request.setExtData(field, data)
         queue.processRequest(request);
+        
+        queue.markAsServiced(request);
+        
         return createKeyRequestInfo(request, uriInfo);
     }
     /**
@@ -181,15 +216,49 @@ public class KeyRequestDAO {
      * @throws EBaseException 
      */
     public KeyRequestInfo submitRequest(RecoveryRequestData data, UriInfo uriInfo) throws EBaseException { 
-        IRequest request = queue.newRequest(IRequest.SECURITY_DATA_RECOVERY_REQUEST);
+        
         // set data using request.setExtData(field, data)
+        
+        String wrappedSessionKeyStr = data.getTransWrappedSessionKey();
+        String wrappedPassPhraseStr = data.getSessionWrappedPassphrase();
+        String nonceDataStr = data.getNonceData();
+        
+        IRequest request = queue.newRequest(IRequest.SECURITY_DATA_RECOVERY_REQUEST);
+        
+        String keyId = data.getKeyId();
+        
+        Hashtable<String, Object> params = null;
+        params = kra.createVolatileRequest(request.getRequestId());
+        
+        CMS.debug("Create volatile  params for recovery request. " + params);
+        
+        if (params != null) {
+            if (wrappedPassPhraseStr != null) {
+                params.put(RecoveryService.ATTR_TRANSPORT_PWD, wrappedPassPhraseStr);
+            }
+            
+            if ( wrappedSessionKeyStr != null) {
+                params.put(IRequest.SECURITY_DATA_TRANS_SESS_KEY, wrappedSessionKeyStr);
+            }
+            
+            if ( nonceDataStr != null) {
+                params.put(IRequest.SECURITY_DATA_IV_STRING_IN, nonceDataStr);
+            }
+        } else {
+            throw new EBaseException("Can not create Volatile params in submitRequest!");
+        }
+        
+        request.setExtData(ATTR_SERIALNO,keyId);
+        
         queue.processRequest(request);
+        
         return createKeyRequestInfo(request, uriInfo);
     }
 
     public void approveRequest(String id) throws EBaseException {
         IRequest request = queue.findRequest(new RequestId(id));
         request.setRequestStatus(RequestStatus.APPROVED);
+        queue.updateRequest(request);
     }
     
     public void rejectRequest(String id) throws EBaseException {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/model/RecoveryRequestData.java b/pki/base/common/src/com/netscape/cms/servlet/request/model/RecoveryRequestData.java
index c84d8f4..64a93ef 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/model/RecoveryRequestData.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/model/RecoveryRequestData.java
@@ -39,6 +39,7 @@ public class RecoveryRequestData {
     private static final String REQUEST_ID = "requestId";
     private static final String TRANS_WRAPPED_SESSION_KEY = "transWrappedSessionKey";
     private static final String SESSION_WRAPPED_PASSPHRASE = "sessionWrappedPassphrase";
+    private static final String NONCE_DATA = "nonceData";
 
     @XmlElement
     protected String keyId;
@@ -52,6 +53,9 @@ public class RecoveryRequestData {
     @XmlElement
     protected String sessionWrappedPassphrase;
     
+    @XmlElement
+    protected String nonceData;
+    
     public RecoveryRequestData() {
         // required for JAXB (defaults)
     }
@@ -61,6 +65,7 @@ public class RecoveryRequestData {
         requestId = form.getFirst(REQUEST_ID);
         transWrappedSessionKey = form.getFirst(TRANS_WRAPPED_SESSION_KEY);
         sessionWrappedPassphrase = form.getFirst(SESSION_WRAPPED_PASSPHRASE);
+        nonceData = form.getFirst(NONCE_DATA);
     }
 
     /**
@@ -118,5 +123,21 @@ public class RecoveryRequestData {
     public void setSessionWrappedPassphrase(String sessionWrappedPassphrase) {
         this.sessionWrappedPassphrase = sessionWrappedPassphrase;
     }
+    
+    /**
+     * @return nonceData
+     */
+    
+    public String getNonceData() {
+        return nonceData;
+    }
+    
+    /**
+     * @param nonceData the nonceData to set
+     */
+    
+    public void setNonceData(String nonceData) {
+        this.nonceData = nonceData;
+    }
 
 }
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/KeyDBSchema.java b/pki/base/common/src/com/netscape/cmscore/dbs/KeyDBSchema.java
index ca9db77..50b3bad 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/KeyDBSchema.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/KeyDBSchema.java
@@ -45,4 +45,7 @@ public class KeyDBSchema {
     public static final String LDAP_ATTR_PUBLIC_KEY_FORMAT =
             "publicKeyFormat";
     public static final String LDAP_ATTR_ARCHIVED_BY = "archivedBy";
+    public static final String LDAP_ATTR_CLIENT_ID = "clientId";
+    public static final String LDAP_ATTR_STATUS = "status";
+    public static final String LDAP_ATTR_DATA_TYPE = "dataType";
 }
